#include "c_signal_handling.h"

/* signal handling */


/* Global flag, so far for mulithreading... */

EIF_OBJ signal_switch = NULL;
#ifndef EIFFEL_VENDOR_SE
EIF_PROCEDURE signal_callback = NULL;
#endif


void epx_clear_signal_switch()
{
  signal_switch = NULL;
#ifndef EIFFEL_VENDOR_SE
  signal_callback = NULL;
#endif
}


void epx_set_signal_switch (EIF_OBJ a_switch)
{
#ifdef EIFFEL_VENDOR_ISE
  EIF_TYPE_ID tid;
  if ( signal_switch != NULL ) {
    eif_wean (signal_switch);
    signal_switch = NULL;
  }
  if ( a_switch != NULL ) {
    signal_switch = eif_adopt (a_switch);
    tid = eif_type_id ("STDC_SIGNAL_SWITCH");
    signal_callback = eif_procedure ("switcher", tid);
    if (signal_callback == 0)
      { eif_panic ("switcher feature not found."); }
  }
#endif
#ifdef EIFFEL_VENDOR_VE
  if ( signal_switch != NULL ) {
    eif_wean (signal_switch);
    signal_switch = NULL;
  }
  if ( a_switch != NULL ) {
    eif_adopt (a_switch);
    signal_switch = a_switch;
    signal_callback = eif_dynamic_routine (signal_switch, "switcher");
  }
#endif
#ifdef EIFFEL_VENDOR_SE
  signal_switch = a_switch;
#endif
}


#ifdef EIFFEL_VENDOR_SE
/* prototype callback function */
void stdc_signal_switch_switcher(EIF_OBJ obj, EIF_INTEGER sig);
#endif

void epx_the_signal_handler (EIF_INTEGER sig)
{
  if (signal_switch != NULL) {
#ifdef EIFFEL_VENDOR_ISE
    (signal_callback) (eif_access(signal_switch), sig);
#endif
#ifdef EIFFEL_VENDOR_VE
    (signal_callback) (eif_access(signal_switch), sig);
#endif
#ifdef EIFFEL_VENDOR_SE
    stdc_signal_switch_switcher (signal_switch, sig);
#endif
  }
}


EIF_POINTER epx_signal_handler()
{
  return (EIF_POINTER)  &epx_the_signal_handler;
}
