indexing

	description: "Base class for MIME single and multipart bodies."

	author: "Berend de Boer"
	date: "$Date: 2003/01/09 $"
	revision: "$Revision: #1 $"

deferred class

	EPX_MIME_BODY


feature -- Queries

	is_multipart: BOOLEAN is
			-- True if body is multipart.
		deferred
		end

	parts_count: INTEGER is
		-- The number of parts if is_multipart.
		deferred
		end

	part (index: INTEGER): EPX_MIME_PART is
			-- Part number `index' if this is a multipart body.
		require
			multipart: is_multipart
			valid_index: index >= 1 and index <= parts_count
		deferred
		end


invariant

	no_parts_if_not_multipart: not is_multipart implies parts_count = 0

end
