indexing

	description: "Field Content-Type"

	author: "Berend de Boer"
	date: "$Date: 2003/01/09 $"
	revision: "$Revision: #1 $"


class

	EPX_MIME_FIELD_CONTENT_TYPE


inherit

	EPX_MIME_FIELD_WITH_PARAMETERS


creation

	make



feature -- Initialization

	make (a_type, a_subtype: STRING) is
			-- Initialize Content-Type.
		require
			type_not_empty: a_type /= Void and then not a_type.is_empty
			subtype_not_empty: a_subtype /= Void and then not a_subtype.is_empty
		do
			type := a_type
			subtype := a_subtype
			make_parameters
		end


feature -- State

	name: STRING is "Content-Type"

	subtype: STRING
			-- More detail about `type'.

	type: STRING
			-- Major MIME type like `multipart' or `message'.

	value: STRING is
			-- Value of field.
		do
			Result := subtype + "/" + type
		end


invariant

	subtype_not_empty: subtype /= Void and then not subtype.is_empty
	type_not_empty: type /= Void and then not type.is_empty

end
