indexing

	description:
		"Scanner for mime messages."

	standards:
		"Based on RFC 822, 2045 and 2047."

	implementation:
		"1. Uses the specials from RFC 2047, so '/', '?' and '=' are%
		%   considered specials as well."

	author: "Berend de Boer"
	date: "$Date: 2003/01/09 $"
	revision: "$Revision: #1 $"


class

	EPX_MIME_SCANNER

inherit

	YY_COMPRESSED_SCANNER_SKELETON
		export
			{EPX_MIME_PARSER} yyEnd_of_file_character
		end

	UT_CHARACTER_CODES
		export {NONE} all end

creation

	make


feature -- Status report

	valid_start_condition (sc: INTEGER): BOOLEAN is
			-- Is `sc' a valid start condition?
		do
			Result := (INITIAL <= sc and sc <= QUOTED_STRING)
		end

feature {NONE} -- Implementation

	yy_build_tables is
			-- Build scanner tables.
		do
			yy_nxt ?= yy_nxt_template
			yy_chk ?= yy_chk_template
			yy_base ?= yy_base_template
			yy_def ?= yy_def_template
			yy_ec ?= yy_ec_template
			yy_meta ?= yy_meta_template
			yy_accept ?= yy_accept_template
		end

	yy_execute_action (yy_act: INTEGER) is
			-- Execute semantic action.
		do
if yy_act <= 34 then
if yy_act <= 17 then
if yy_act <= 9 then
if yy_act <= 5 then
if yy_act <= 3 then
if yy_act <= 2 then
if yy_act = 1 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 60 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 60")
end
-- Ignore white space
else
	yy_column := yy_column + 19
--|#line 64 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 64")
end

							last_token := mime_tokens.FN_CONTENT_DISPOSITION
							to_condition := STRUCTURED_FIELD_BODY
							
end
else
	yy_column := yy_column + 14
--|#line 68 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 68")
end

							last_token := mime_tokens.FN_CONTENT_LENGTH
							to_condition := STRUCTURED_FIELD_BODY
							
end
else
if yy_act = 4 then
	yy_column := yy_column + 12
--|#line 72 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 72")
end

							last_token := mime_tokens.FN_CONTENT_TYPE
							to_condition := STRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + 4
--|#line 76 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 76")
end

							last_token := mime_tokens.FN_DATE
							to_condition := STRUCTURED_FIELD_BODY
							
end
end
else
if yy_act <= 7 then
if yy_act = 6 then
	yy_column := yy_column + 4
--|#line 80 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 80")
end

							last_token := mime_tokens.FN_FROM
							to_condition := STRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + 10
--|#line 84 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 84")
end

							last_token := mime_tokens.FN_MESSAGE_ID
							to_condition := STRUCTURED_FIELD_BODY
							
end
else
if yy_act = 8 then
	yy_column := yy_column + 12
--|#line 88 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 88")
end

							last_token := mime_tokens.FN_VERSION
							to_condition := STRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + 8
--|#line 92 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 92")
end

							last_token := mime_tokens.FN_RECEIVED
							to_condition := STRUCTURED_FIELD_BODY
							
end
end
end
else
if yy_act <= 13 then
if yy_act <= 11 then
if yy_act = 10 then
	yy_column := yy_column + 11
--|#line 96 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 96")
end

							last_token := mime_tokens.FN_RESENT_FROM
							to_condition := STRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + 15
--|#line 100 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 100")
end

							last_token := mime_tokens.FN_RESENT_REPLY_TO
							to_condition := STRUCTURED_FIELD_BODY
							
end
else
if yy_act = 12 then
	yy_column := yy_column + 13
--|#line 104 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 104")
end

							last_token := mime_tokens.FN_RESENT_SENDER
							to_condition := STRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + 11
--|#line 108 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 108")
end

							last_token := mime_tokens.FN_RETURN_PATH
							to_condition := STRUCTURED_FIELD_BODY
							
end
end
else
if yy_act <= 15 then
if yy_act = 14 then
	yy_column := yy_column + 6
--|#line 112 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 112")
end

							last_token := mime_tokens.FN_SENDER
							to_condition := STRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + 2
--|#line 116 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 116")
end

							last_token := mime_tokens.FN_TO
							to_condition := STRUCTURED_FIELD_BODY
							
end
else
if yy_act = 16 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 124 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 124")
end

							last_token := mime_tokens.FIELD_NAME
							last_value := text
							to_condition := UNSTRUCTURED_FIELD_BODY
							
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 130 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 130")
end
 -- include space, so it's already skipped
							last_value := STRING_.make (64)
							last_token := Colon_code
							if to_condition /= 0 then
								set_start_condition (to_condition)
							end
							
end
end
end
end
else
if yy_act <= 26 then
if yy_act <= 22 then
if yy_act <= 20 then
if yy_act <= 19 then
if yy_act = 18 then
	yy_line := yy_line + 2
	yy_column := 1
--|#line 138 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 138")
end

							last_token := mime_tokens.NULL_LINE
							
else
	yy_line := yy_line + 2
	yy_column := 1
--|#line 139 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 139")
end

							last_token := mime_tokens.NULL_LINE
							
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 146 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 146")
end
 -- White space, ignore
							optional_start_keyword
							
end
else
if yy_act = 21 then
	yy_column := yy_column + 2
--|#line 150 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 150")
end
 last_token := mime_tokens.ENCODED_WORD_START 
else
	yy_column := yy_column + 1
--|#line 151 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 151")
end
 last_token := Less_than_code 
end
end
else
if yy_act <= 24 then
if yy_act = 23 then
	yy_column := yy_column + 1
--|#line 152 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 152")
end
 last_token := Greater_than_code 
else
	yy_column := yy_column + 1
--|#line 153 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 153")
end
 last_token := At_code 
end
else
if yy_act = 25 then
	yy_column := yy_column + 1
--|#line 154 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 154")
end
 last_token := Comma_code 
else
	yy_column := yy_column + 1
--|#line 155 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 155")
end
 last_token := Semicolon_code 
end
end
end
else
if yy_act <= 30 then
if yy_act <= 28 then
if yy_act = 27 then
	yy_column := yy_column + 1
--|#line 156 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 156")
end
 last_token := Colon_code 
else
	yy_column := yy_column + 1
--|#line 157 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 157")
end
 last_token := Backslash_code 
end
else
if yy_act = 29 then
	yy_column := yy_column + 1
--|#line 158 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 158")
end
 last_token := Dot_code 
else
	yy_column := yy_column + 1
--|#line 159 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 159")
end
 last_token := Equal_code 
end
end
else
if yy_act <= 32 then
if yy_act = 31 then
	yy_column := yy_column + 1
--|#line 160 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 160")
end
 last_token := Slash_code 
else
	yy_column := yy_column + 1
--|#line 161 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 161")
end
 last_token := Question_mark_code 
end
else
if yy_act = 33 then
	yy_column := yy_column + 1
--|#line 162 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 162")
end

							optional_start_keyword
							set_start_condition (COMMENT)
							
else
	yy_column := yy_column + 1
--|#line 166 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 166")
end

							last_value := STRING_.make (32)
							set_start_condition (DOMAIN_LITERAL)
							
end
end
end
end
end
else
if yy_act <= 51 then
if yy_act <= 43 then
if yy_act <= 39 then
if yy_act <= 37 then
if yy_act <= 36 then
if yy_act = 35 then
	yy_column := yy_column + 1
--|#line 170 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 170")
end
 --"
							last_value := STRING_.make (32)
							set_start_condition (QUOTED_STRING)
							
else
yy_set_column (1)
--|#line 174 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 174")
end
 -- Folded-line white space, ignore
							optional_start_keyword
							
end
else
	yy_line := yy_line + 2
	yy_column := 1
--|#line 177 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 177")
end

							last_token := mime_tokens.NULL_LINE
							stop_keyword
							set_start_condition (INITIAL)
							to_condition := 0
							
end
else
if yy_act = 38 then
	yy_line := yy_line + 2
	yy_column := 1
--|#line 178 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 178")
end

							last_token := mime_tokens.NULL_LINE
							stop_keyword
							set_start_condition (INITIAL)
							to_condition := 0
							
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 184 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 184")
end

							stop_keyword
							set_start_condition (INITIAL)
							to_condition := 0
							
end
end
else
if yy_act <= 41 then
if yy_act = 40 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 189 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 189")
end
 --"
							last_value := text
							if expect_keyword then
								if is_keyword (last_value) then
									last_token := last_keyword
								else
									last_token := mime_tokens.ATOM
								end
								temporarily_stop_keyword
							else
								if call_enable_keyword_after_space then
									enable_keyword_after_space
								end
								last_token := mime_tokens.ATOM
							end
							
else
	yy_column := yy_column + 1
--|#line 205 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 205")
end
-- ignore all other stuff??
end
else
if yy_act = 42 then
	yy_column := yy_column + 2
--|#line 210 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 210")
end
 
else
	yy_column := yy_column + 2
--|#line 211 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 211")
end
 
end
end
end
else
if yy_act <= 47 then
if yy_act <= 45 then
if yy_act = 44 then
	yy_column := yy_column + 1
--|#line 212 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 212")
end

							if nested_comment_count = 0 then
								set_start_condition (to_condition)
							else
								nested_comment_count := nested_comment_count - 1
							end
							
else
	yy_column := yy_column + 1
--|#line 219 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 219")
end
 nested_comment_count := nested_comment_count + 1 
end
else
if yy_act = 46 then
yy_set_line_column
--|#line 220 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 220")
end
 
else
	yy_column := yy_column + 2
--|#line 226 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 226")
end
 last_value.append_character (text.item (2)) 
end
end
else
if yy_act <= 49 then
if yy_act = 48 then
	yy_column := yy_column + 1
--|#line 227 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 227")
end

							set_start_condition (to_condition)
							last_token := mime_tokens.DOMAIN_LITERAL
							
else
yy_set_column (1)
--|#line 231 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 231")
end

							last_value.append_character (' ')
							
end
else
if yy_act = 50 then
yy_set_line_column
--|#line 234 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 234")
end
 last_value.append_string (text) 
else
	yy_column := yy_column + 2
--|#line 239 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 239")
end
 last_value.append_character (text.item (2)) 
end
end
end
end
else
if yy_act <= 59 then
if yy_act <= 55 then
if yy_act <= 53 then
if yy_act = 52 then
	yy_column := yy_column + 1
--|#line 240 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 240")
end
 --"
							set_start_condition (to_condition)
							last_token := mime_tokens.QUOTED_STRING
							
else
yy_set_column (1)
--|#line 244 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 244")
end

							last_value.append_character (' ')
							
end
else
if yy_act = 54 then
yy_set_line_column
--|#line 247 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 247")
end
 --"
							last_value.append_string (text)
							
else
	yy_column := yy_column + 2
--|#line 254 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 254")
end
 last_token := mime_tokens.ENCODED_WORD_STOP 
end
end
else
if yy_act <= 57 then
if yy_act = 56 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 255 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 255")
end

							last_value := text
							last_token := mime_tokens.ENCODED_TEXT
							
else
	yy_column := yy_column + 1
--|#line 259 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 259")
end
 set_start_condition (to_condition) 
end
else
if yy_act = 58 then
	yy_column := yy_column + 1
--|#line 264 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 264")
end

							set_start_condition (COMMENT) 
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 266 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 266")
end

							last_value.append_string (text)
							
end
end
end
else
if yy_act <= 63 then
if yy_act <= 61 then
if yy_act = 60 then
yy_set_column (1)
--|#line 269 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 269")
end

							last_value.append_character (' ')
							
else
	yy_line := yy_line + 2
	yy_column := 1
--|#line 272 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 272")
end

							less (0)
							last_token := mime_tokens.FIELD_BODY
							set_start_condition (INITIAL)
							
end
else
if yy_act = 62 then
	yy_line := yy_line + 2
	yy_column := 1
--|#line 273 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 273")
end

							less (0)
							last_token := mime_tokens.FIELD_BODY
							set_start_condition (INITIAL)
							
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 278 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 278")
end

							last_token := mime_tokens.FIELD_BODY
							set_start_condition (INITIAL)
							
end
end
else
if yy_act <= 65 then
if yy_act = 64 then
	yy_column := yy_column + 1
--|#line 282 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 282")
end
-- ignore lone CR's
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 287 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 287")
end

						  last_token := mime_tokens.CRLF
						  
end
else
if yy_act = 66 then
	yy_column := yy_column + 1
--|#line 294 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 294")
end
-- ignore all other charcters, i.e. ascii unprintables and high ascii
else
yy_set_line_column
--|#line 0 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 0")
end
last_token := yyError_token
fatal_error ("scanner jammed")
end
end
end
end
end
end
		end

	yy_execute_eof_action (yy_sc: INTEGER) is
			-- Execute EOF semantic action.
		do
			inspect yy_sc
when 0, 1, 2, 3, 4, 5, 6, 7 then
--|#line 0 "epx_mime_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'epx_mime_scanner.l' at line 0")
end
 terminate 
			else
				terminate
			end
		end

feature {NONE} -- Table templates

	yy_nxt_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,   18,   19,   20,   21,   22,   33,   34,   33,   34,
			  209,   35,   73,   35,   24,   73,   56,   57,   56,   57,
			   60,   61,   25,   26,   73,   27,   78,   76,  209,   78,
			   28,   60,   61,  209,   29,   30,   31,   64,   64,   65,
			   64,   64,  209,   18,   18,   19,   20,   21,   22,   58,
			  209,   58,  209,  209,  209,   67,  209,   24,   62,   63,
			   81,   80,  209,   79,   91,   25,   26,   91,   27,   62,
			   63,  138,   82,   28,   84,   85,   83,   29,   30,   31,
			   88,   89,  101,   88,   86,  101,   18,   36,   37,   38,
			   39,   37,   40,   41,   42,   36,   43,   40,   44,   45,

			   46,   47,   48,   49,   50,   51,   52,   40,   40,   40,
			   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
			   40,   40,   40,   40,   40,   40,   53,   54,   36,   36,
			   64,   64,   65,   64,   64,   69,   70,   69,   70,   71,
			  100,   71,   92,   93,  209,   92,   98,   99,   67,  108,
			  107,  209,  108,   73,  111,   73,   73,   78,   76,  209,
			   78,  209,  209,  209,  209,   88,  209,   88,   88,  122,
			   88,   91,  209,   72,   91,   72,  209,  209,  114,  104,
			  113,   92,  209,  118,   92,   92,  209,  123,   92,  115,
			  117,  209,  101,  121,  116,  101,  119,  120,  101,  108,

			  108,  101,  108,  108,  126,  127,  125,  209,  129,  128,
			  209,  209,  209,  130,  209,  209,  209,  209,  209,  209,
			  209,  209,  209,  209,  209,  209,  209,  209,  209,  131,
			  209,  209,  133,  137,  136,  209,  154,  209,  209,  209,
			  142,  139,  209,  144,  155,  132,  140,  156,  141,  143,
			  151,  157,  148,  152,  209,  209,  149,  145,  146,  147,
			  150,  153,  158,  209,  209,  209,  209,  209,  163,  209,
			  209,  209,  209,  209,  209,  159,  209,  209,  160,  209,
			  209,  209,  209,  209,  164,  209,  209,  161,  162,  170,
			  165,  167,  171,  172,  174,  173,  169,  166,  176,  168,

			  209,  209,  177,  178,  209,  209,  209,  209,  175,  180,
			  179,  183,  209,  186,  209,  181,  182,  184,  209,  209,
			  209,  209,  209,  209,  209,  188,  209,  209,  187,  192,
			  185,  189,  198,  209,  209,  209,  190,  209,  191,  209,
			  209,  193,  195,  209,  209,  209,   95,  209,  209,  196,
			   95,  201,  209,  199,  209,  194,  197,  200,   95,  203,
			  209,  202,  209,  206,  204,  209,  135,  134,  208,  205,
			  207,   23,   23,   23,   23,   23,   23,   23,   23,   23,
			   23,   23,   23,   23,   23,   23,   23,   23,   23,   32,
			   32,   32,   32,   32,   32,   32,   32,   32,   32,   32,

			   32,   32,   32,   32,   32,   32,   32,   55,   55,   55,
			   55,   55,   55,   55,   55,   55,   55,   55,   55,   55,
			   55,   55,   55,   55,   55,   59,   59,   59,   59,   59,
			   59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
			   59,   59,   59,   66,   66,   66,   66,   66,   66,   66,
			   66,   66,   66,   66,   66,   66,   66,   66,   66,   66,
			   66,   65,   65,   65,   65,   65,   65,   65,   65,   65,
			   65,   65,   65,   65,   65,   65,   65,   65,   65,   68,
			   68,   68,   68,   68,   68,   68,   68,   68,   68,   68,
			   68,   68,   68,   68,   68,   68,   68,   77,  124,   77,

			   77,   77,   77,   77,   77,  209,   77,   77,   77,   77,
			   77,   77,   77,   77,   87,   87,  209,   87,   87,   87,
			   87,   87,   87,   87,   87,   87,   87,   87,   87,   87,
			   87,   87,   97,   97,   97,   97,   97,  112,   97,   97,
			   97,   97,   97,   97,   97,   97,   97,   97,   97,   97,
			  100,  100,  100,  100,  100,  100,  100,  100,  100,  100,
			  100,  100,  100,  100,  100,  100,  100,  103,  103,  103,
			  103,  103,  103,  103,  103,  103,  103,  103,  103,  103,
			  103,  103,  103,  103,  103,  105,  105,  105,  105,  105,
			  105,  105,  105,  105,  105,  105,  105,  105,  105,  105,

			  107,  107,  107,  107,  109,  107,  107,  107,  107,  107,
			  107,  107,  107,  107,  107,  107,  107,  107,  110,  110,
			  110,  110,  110,  110,  110,  110,  110,  110,  110,  110,
			  110,  110,  110,  110,  110,  110,  106,  102,   96,   94,
			   90,  209,   75,   74,  209,   17,  209,  209,  209,  209,
			  209,  209,  209,  209,  209,  209,  209,  209,  209,  209,
			  209,  209,  209,  209,  209,  209,  209,  209,  209,  209,
			  209,  209,  209,  209,  209,  209,  209,  209,  209,  209,
			  209,  209,  209,  209,  209,  209,  209,  209,  209>>)
		end

	yy_chk_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    3,    3,    4,    4,
			  208,    3,   19,    4,    1,   19,    7,    7,    8,    8,
			    9,    9,    1,    1,   22,    1,   24,   22,   27,   24,
			    1,   10,   10,   25,    1,    1,    1,   11,   11,   11,
			   11,   11,   26,    1,    2,    2,    2,    2,    2,    7,
			   28,    8,   29,   30,   31,   11,  204,    2,    9,    9,
			   27,   26,  129,   25,   37,    2,    2,   37,    2,   10,
			   10,  129,   28,    2,   29,   30,   28,    2,    2,    2,
			   33,   33,   60,   33,   31,   60,    2,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,

			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			   12,   12,   12,   12,   12,   15,   15,   16,   16,   15,
			   62,   16,   38,   38,   80,   38,   58,   58,   12,   69,
			   72,   79,   69,   73,   72,   76,   73,   78,   76,   81,
			   78,   82,   83,   84,   85,   88,  201,   90,   88,   90,
			   90,   91,  113,   15,   91,   16,  116,  115,   80,   62,
			   79,   92,  114,   84,   92,   94,  117,   94,   94,   81,
			   83,  118,  101,   85,   82,  101,   84,   84,  102,  108,

			  109,  102,  108,  109,  114,  115,  113,  119,  117,  116,
			  120,  121,  125,  118,  128,  130,  132,  131,  133,  137,
			  136,  138,  139,  141,  142,  140,  143,  147,  144,  119,
			  152,  145,  121,  128,  125,  148,  147,  155,  150,  146,
			  133,  130,  151,  137,  148,  120,  131,  150,  132,  136,
			  144,  151,  141,  145,  153,  154,  142,  138,  139,  140,
			  143,  146,  152,  156,  160,  157,  158,  161,  155,  164,
			  162,  166,  165,  169,  163,  153,  168,  167,  154,  170,
			  171,  172,  174,  173,  156,  178,  175,  154,  154,  161,
			  156,  157,  162,  163,  165,  164,  160,  156,  167,  158,

			  177,  179,  168,  169,  180,  182,  181,  184,  166,  171,
			  170,  174,  185,  178,  183,  172,  173,  175,  187,  190,
			  188,  195,  191,  194,  196,  180,  197,  198,  179,  184,
			  177,  181,  194,  200,  202,  203,  182,  205,  183,  207,
			  206,  185,  188,  199,  193,  192,  219,  189,  186,  190,
			  219,  197,  176,  195,  159,  187,  191,  196,  219,  200,
			  149,  198,  127,  205,  202,  126,  123,  122,  207,  203,
			  206,  210,  210,  210,  210,  210,  210,  210,  210,  210,
			  210,  210,  210,  210,  210,  210,  210,  210,  210,  211,
			  211,  211,  211,  211,  211,  211,  211,  211,  211,  211,

			  211,  211,  211,  211,  211,  211,  211,  212,  212,  212,
			  212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
			  212,  212,  212,  212,  212,  213,  213,  213,  213,  213,
			  213,  213,  213,  213,  213,  213,  213,  213,  213,  213,
			  213,  213,  213,  214,  214,  214,  214,  214,  214,  214,
			  214,  214,  214,  214,  214,  214,  214,  214,  214,  214,
			  214,  215,  215,  215,  215,  215,  215,  215,  215,  215,
			  215,  215,  215,  215,  215,  215,  215,  215,  215,  216,
			  216,  216,  216,  216,  216,  216,  216,  216,  216,  216,
			  216,  216,  216,  216,  216,  216,  216,  217,  112,  217,

			  217,  217,  217,  217,  217,   86,  217,  217,  217,  217,
			  217,  217,  217,  217,  218,  218,   77,  218,  218,  218,
			  218,  218,  218,  218,  218,  218,  218,  218,  218,  218,
			  218,  218,  220,  220,  220,  220,  220,   75,  220,  220,
			  220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
			  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
			  221,  221,  221,  221,  221,  221,  221,  222,  222,  222,
			  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
			  222,  222,  222,  222,  222,  223,  223,  223,  223,  223,
			  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,

			  224,  224,  224,  224,   70,  224,  224,  224,  224,  224,
			  224,  224,  224,  224,  224,  224,  224,  224,  225,  225,
			  225,  225,  225,  225,  225,  225,  225,  225,  225,  225,
			  225,  225,  225,  225,  225,  225,   67,   61,   49,   39,
			   34,   23,   21,   20,   17,  209,  209,  209,  209,  209,
			  209,  209,  209,  209,  209,  209,  209,  209,  209,  209,
			  209,  209,  209,  209,  209,  209,  209,  209,  209,  209,
			  209,  209,  209,  209,  209,  209,  209,  209,  209,  209,
			  209,  209,  209,  209,  209,  209,  209,  209,  209>>)
		end

	yy_base_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    0,   43,    3,    5,   86,    0,    8,   10,   17,
			   28,   36,  129,    0,    0,  132,  134,  644,  645,   10,
			  640,  639,   22,  639,   24,   31,   40,   26,   48,   50,
			   51,   52,    0,   78,  637,    0,  645,   62,  140,  636,
			    0,  645,  645,  645,  645,  645,  645,  645,  645,  619,
			  645,  645,  645,  645,  645,    0,  645,  645,  138,    0,
			   80,  634,  137,  645,  645,  645,    0,  619,    0,  147,
			  601,  645,  147,  151,  645,  533,  153,  514,  155,  149,
			  142,  157,  159,  160,  161,  162,  503,    0,  163,  645,
			  165,  169,  179,  645,  183,    0,  645,    0,  645,  645,

			    0,  190,  196,    0,  645,    0,  645,    0,  197,  198,
			    0,  645,  495,  170,  180,  175,  174,  184,  189,  205,
			  208,  209,  364,  363,  645,  210,  363,  360,  212,   60,
			  213,  215,  214,  216,  645,  645,  218,  217,  219,  220,
			  223,  221,  222,  224,  226,  229,  237,  225,  233,  358,
			  236,  240,  228,  252,  253,  235,  261,  263,  264,  352,
			  262,  265,  268,  272,  267,  270,  269,  275,  274,  271,
			  277,  278,  279,  281,  280,  284,  350,  298,  283,  299,
			  302,  304,  303,  312,  305,  310,  346,  316,  318,  345,
			  317,  320,  343,  342,  321,  319,  322,  324,  325,  341,

			  331,  164,  332,  333,   54,  335,  338,  337,    8,  645,
			  370,  388,  406,  424,  442,  460,  478,  495,  513,  342,
			  531,  549,  566,  581,  599,  617>>)
		end

	yy_def_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,  210,  210,  211,  211,  209,    5,  212,  212,  213,
			  213,  214,  214,  215,  215,  216,  216,  209,  209,  209,
			  209,  209,  217,  217,  209,  217,  217,  217,  217,  217,
			  217,  217,  218,  209,  209,  218,  209,  209,  209,  209,
			  219,  209,  209,  209,  209,  209,  209,  209,  209,  209,
			  209,  209,  209,  209,  209,  220,  209,  209,  220,  221,
			  221,  221,  222,  209,  209,  209,  223,  209,  224,  224,
			  224,  209,  225,  209,  209,  209,  217,  217,  209,  217,
			  217,  217,  217,  217,  217,  217,  217,  218,  209,  209,
			  209,  209,  209,  209,  209,  219,  209,  220,  209,  209,

			  221,  221,  221,  221,  209,  223,  209,  224,  224,  224,
			  224,  209,  209,  217,  217,  217,  217,  217,  217,  217,
			  217,  217,  209,  209,  209,  217,  217,  217,  217,  217,
			  217,  217,  217,  217,  209,  209,  217,  217,  217,  217,
			  217,  217,  217,  217,  217,  217,  217,  217,  217,  217,
			  217,  217,  217,  217,  217,  217,  217,  217,  217,  217,
			  217,  217,  217,  217,  217,  217,  217,  217,  217,  217,
			  217,  217,  217,  217,  217,  217,  217,  217,  217,  217,
			  217,  217,  217,  217,  217,  217,  217,  217,  217,  217,
			  217,  217,  217,  217,  217,  217,  217,  217,  217,  217,

			  217,  217,  217,  217,  217,  217,  217,  217,  217,    0,
			  209,  209,  209,  209,  209,  209,  209,  209,  209,  209,
			  209,  209,  209,  209,  209,  209>>)
		end

	yy_ec_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    2,
			    3,    1,    1,    4,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    5,    6,    7,    6,    6,    6,    6,    6,
			    8,    9,    6,    6,   10,   11,   12,   13,    6,    6,
			    6,    6,    6,    6,    6,    6,    6,    6,   14,   15,
			   16,   17,   18,   19,   20,   21,    6,   22,   23,   24,
			   25,   26,   27,   28,    6,    6,   29,   30,   31,   32,
			   33,    6,   34,   35,   36,   37,   38,    6,    6,   39,
			    6,   40,   41,   42,    6,    6,    6,   21,    6,   22,

			   23,   24,   25,   26,   27,   28,    6,    6,   29,   30,
			   31,   32,   33,    6,   34,   35,   36,   37,   38,    6,
			    6,   39,    6,    6,    6,    6,    6,   43,   43,   43,
			   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
			   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
			   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
			   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
			   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
			   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
			   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,

			   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
			   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
			   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
			   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
			   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
			   43,   43,   43,   43,   43,   43,    1>>)
		end

	yy_meta_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    2,    3,    3,    2,    4,    5,    6,    6,
			    7,    8,    9,    7,   10,   11,   12,   13,   14,    2,
			   15,    4,    4,    4,    4,    4,    4,    4,    4,    4,
			    4,    4,    4,    4,    4,    4,    4,    4,   16,    4,
			    7,   17,   18,   10>>)
		end

	yy_accept_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,   68,   66,    1,
			   65,   66,    1,   16,   66,   16,   16,   16,   16,   16,
			   16,   16,   59,   63,   64,   58,   41,   20,   39,   41,
			   40,   35,   33,   25,   29,   31,   27,   26,   22,   30,
			   23,   32,   24,   34,   28,   46,   45,   44,   46,   50,
			   50,   50,   50,   48,   57,   67,   56,   57,   54,   54,
			   54,   52,   54,    1,   19,   65,    1,   16,   17,   16,
			   16,   16,   16,   16,   16,   16,   15,   59,   60,   61,
			   63,   20,   36,   37,   39,   40,   21,   46,   42,   43,

			   50,   49,   50,   47,   47,   56,   55,   54,   53,   54,
			   51,   51,    0,   16,   16,   16,   16,   16,   16,   16,
			   16,   16,    0,    0,   18,   16,    5,    6,   16,   16,
			   16,   16,   16,   16,   62,   38,   16,   16,   16,   16,
			   16,   16,   16,   16,   16,   16,   16,   16,   16,   14,
			   16,   16,   16,   16,   16,   16,   16,   16,   16,    9,
			   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
			   16,   16,   16,   16,   16,   16,    7,   16,   16,   16,
			   16,   16,   16,   16,   16,   16,   10,   16,   16,   13,
			   16,   16,    4,    8,   16,   16,   16,   16,   16,   12,

			   16,    3,   16,   16,   11,   16,   16,   16,    2,    0>>)
		end

feature {NONE} -- Constants

	yyJam_base: INTEGER is 645
			-- Position in `yy_nxt'/`yy_chk' tables
			-- where default jam table starts

	yyJam_state: INTEGER is 209
			-- State id corresponding to jam state

	yyTemplate_mark: INTEGER is 210
			-- Mark between normal states and templates

	yyNull_equiv_class: INTEGER is 1
			-- Equivalence code for NULL character

	yyReject_used: BOOLEAN is false
			-- Is `reject' called?

	yyVariable_trail_context: BOOLEAN is false
			-- Is there a regular expression with
			-- both leading and trailing parts having
			-- variable length?

	yyReject_or_variable_trail_context: BOOLEAN is false
			-- Is `reject' called or is there a
			-- regular expression with both leading
			-- and trailing parts having variable length?

	yyNb_rules: INTEGER is 67
			-- Number of rules

	yyEnd_of_buffer: INTEGER is 68
			-- End of buffer rule code

	yyLine_used: BOOLEAN is true
			-- Are line and column numbers used?

	yyPosition_used: BOOLEAN is false
			-- Is `position' used?

	INITIAL: INTEGER is 0
	UNSTRUCTURED_FIELD_BODY: INTEGER is 1
	STRUCTURED_FIELD_BODY: INTEGER is 2
	COMMENT: INTEGER is 3
	DOMAIN_LITERAL: INTEGER is 4
	ENCODED_TEXT: INTEGER is 5
	NEXT_WORD: INTEGER is 6
	QUOTED_STRING: INTEGER is 7
			-- Start condition codes

feature -- User-defined features



feature -- Last returned data

	last_value: STRING


feature -- Buffer setting

	new_stdc_file_buffer (a_file: STDC_TEXT_FILE): EPX_FILE_BUFFER is
			-- New input buffer for `a_file'.
		require
			file_not_void: a_file /= Void
			file_open: a_file.is_open
		do
			create Result.make (a_file)
		ensure
			new_buffer_not_void: Result /= Void
		end

	new_file_descriptor_buffer (a_fd: ABSTRACT_FILE_DESCRIPTOR): EPX_FILE_DESCRIPTOR_BUFFER is
			-- New input buffer for `a_fd'.
		require
			file_descriptor_not_void: a_fd /= Void
			file_descriptor_open: a_fd.is_open
		do
			create Result.make (a_fd)
		ensure
			new_buffer_not_void: Result /= Void
		end

feature -- Condition setting

	enable_keyword_after_space is
		do
			expect_keyword_after_space := True
		ensure
			no_keywords: not expect_keyword
		end

	optional_start_keyword is
			-- Start expect keyword if `expect_keyword_after_space'.
		do
			if expect_keyword_after_space  then
				start_keyword
			end
		ensure
			keyword_started:
				expect_keyword_after_space implies expect_keyword
		end

	reset_start_condition is
			-- Used in error recovery to return to start condition.
		do
			set_start_condition (INITIAL)
		end

	start_encoded_text is
			-- Next atom is encoded text.
		do
			set_start_condition (ENCODED_TEXT)
		end

	start_keyword is
			-- Treat certain atoms specially.
			-- The next atom will be tested if it is a keyword.
			-- The next atom will be treated as an atom, but the first
			-- space, folded-line or comment will turn keyword on at again,
			-- and so forth.
			-- This trick makes the scanner only slightly more state-full
			-- and the parser a lot simpler.
		do
			expect_keyword := True
		ensure
			expect_keywords: expect_keyword
		end

	stop_keyword is
			-- Stop treating certain atoms specially.
		do
			expect_keyword := False
			expect_keyword_after_space := False
			call_enable_keyword_after_space := False
		ensure
			no_more_keywords:
				not expect_keyword and
				not expect_keyword_after_space and
				not call_enable_keyword_after_space
		end

	temporarily_stop_keyword is
			-- Stop treating certain atoms specially for now, but set a
			-- flag so they will be enabled after the first space or
			-- comment.
		do
			expect_keyword := False
			expect_keyword_after_space := False
			call_enable_keyword_after_space := True
		ensure
			no_more_keywords_now:
				not expect_keyword and
				not expect_keyword_after_space
			keywords_later: call_enable_keyword_after_space
		end


feature {NONE} -- Mime specific tokens

	mime_tokens: expanded EPX_MIME_TOKENS

feature {NONE} -- State during parsing

	call_enable_keyword_after_space: BOOLEAN
			-- Flag to call `enable_keyword_after_space' when encountered an ATOM.

	expect_keyword: BOOLEAN
			-- Treat certain atoms specially.

	expect_keyword_after_space: BOOLEAN
			-- Treat certain atoms specially after a space, crlf in
			-- folded-line or comment has been ecountered.

	to_condition: INTEGER
			-- Used by ':' to switch to correct field body parser.

	nested_comment_count: INTEGER
			-- Keep track of nested comments.

	is_keyword (a_word: STRING): BOOLEAN is
			-- True if `a_word' is in `keywords'.
		local
			upper_word: STRING
		do
			upper_word := clone (a_word)
			upper_word.to_upper
			keywords.search (upper_word)
			Result := keywords.found
		end

	keywords: DS_HASH_TABLE [INTEGER, STRING] is
			-- List of atoms that can be treated as a keyword.
		once
			create Result.make (64)
			keywords.put (mime_tokens.KW_BY, "BY")
			keywords.put (mime_tokens.KW_FOR, "FOR")
			keywords.put (mime_tokens.KW_FROM, "FROM")
			keywords.put (mime_tokens.KW_ID, "ID")
			keywords.put (mime_tokens.KW_MULTIPART, "MULTIPART")
			keywords.put (mime_tokens.KW_VIA, "VIA")
			keywords.put (mime_tokens.KW_WITH, "WITH")

			keywords.put (mime_tokens.KW_SUN, "SUN")
			keywords.put (mime_tokens.KW_MON, "MON")
			keywords.put (mime_tokens.KW_TUE, "TUE")
			keywords.put (mime_tokens.KW_WED, "WED")
			keywords.put (mime_tokens.KW_THU, "THU")
			keywords.put (mime_tokens.KW_FRI, "FRI")
			keywords.put (mime_tokens.KW_SAT, "SAT")
		ensure
			result_not_void: Result /= Void
		end

	last_keyword: INTEGER is
			-- Last keyword if `is_keyword' returned True.
		do
			Result := keywords.found_item
		end


invariant

	never_a_keyword_in_start_condition:
		start_condition = INITIAL implies
			(not expect_keyword and not expect_keyword_after_space)

end
