indexing

   description: "SUS symbolic constants"

   author: "Berend de Boer"
   date: "$Date: 2002/02/06 $"
   revision: "$Revision: #2 $"

class

   SUS_CONSTANTS


inherit

   POSIX_CONSTANTS


feature -- syslog facility codes

   LOG_KERN: INTEGER is
         -- kernel messages
      external "C"
      alias "const_log_kern"
      end

   LOG_USER: INTEGER is
         -- random user-level messages
      external "C"
      alias "const_log_user"
      end

   LOG_MAIL: INTEGER is
         -- mail system
      external "C"
      alias "const_log_mail"
      end

   LOG_DAEMON: INTEGER is
         -- system daemons
      external "C"
      alias "const_log_daemon"
      end

   LOG_AUTH: INTEGER is
         -- security/authorization messages
      external "C"
      alias "const_log_auth"
      end

   LOG_LPR: INTEGER is
         -- line printer subsystem
      external "C"
      alias "const_log_lpr"
      end

   LOG_NEWS: INTEGER is
         -- network news subsystem
      external "C"
      alias "const_log_news"
      end

   LOG_UUCP: INTEGER is
         -- UUCP subsystem
      external "C"
      alias "const_log_uucp"
      end

   LOG_CRON: INTEGER is
         -- clock daemon
      external "C"
      alias "const_log_cron"
      end

   LOG_LOCAL0: INTEGER is
         -- Reserved for local use
      external "C"
      alias "const_log_local0"
      end

   LOG_LOCAL1: INTEGER is
         -- Reserved for local use
      external "C"
      alias "const_log_local1"
      end

   LOG_LOCAL2: INTEGER is
         -- Reserved for local use
      external "C"
      alias "const_log_local2"
      end

   LOG_LOCAL3: INTEGER is
         -- Reserved for local use
      external "C"
      alias "const_log_local3"
      end

   LOG_LOCAL4: INTEGER is
         -- Reserved for local use
      external "C"
      alias "const_log_local4"
      end

   LOG_LOCAL5: INTEGER is
         -- Reserved for local use
      external "C"
      alias "const_log_local5"
      end

   LOG_LOCAL6: INTEGER is
         -- Reserved for local use
      external "C"
      alias "const_log_local6"
      end

   LOG_LOCAL7: INTEGER is
         -- Reserved for local use
      external "C"
      alias "const_log_local7"
      end


feature -- syslog open options

   LOG_PID: INTEGER is
         -- log the pid with each message
      external "C"
      alias "const_log_pid"
      end

   LOG_CONS: INTEGER is
         -- log on the console if errors in sending
      external "C"
      alias "const_log_cons"
      end

   LOG_ODELAY: INTEGER is
         -- delay open until first syslog() (default)
      external "C"
      alias "const_log_odelay"
      end

   LOG_NDELAY: INTEGER is
         -- don't delay open
      external "C"
      alias "const_log_ndelay"
      end


feature {NONE} -- syslog priorities

   LOG_EMERG: INTEGER is
      external "C"
      alias "const_log_emerg"
      end

   LOG_ALERT: INTEGER is
      external "C"
      alias "const_log_alert"
      end

   LOG_CRIT: INTEGER is
      external "C"
      alias "const_log_crit"
      end

   LOG_ERR: INTEGER is
      external "C"
      alias "const_log_err"
      end

   LOG_WARNING: INTEGER is
      external "C"
      alias "const_log_warning"
      end

   LOG_NOTICE: INTEGER is
      external "C"
      alias "const_log_notice"
      end

   LOG_INFO: INTEGER is
      external "C"
      alias "const_log_info"
      end

   LOG_DEBUG: INTEGER is
      external "C"
      alias "const_log_debug"
      end


feature {NONE} -- kinds of socket

   SOCK_DGRAM: INTEGER is
         -- Connectionless, unreliable datagrams of fixed maximum length.
      external "C"
      alias "const_sock_dgram"
      end

   SOCK_PACKET: INTEGER is
         -- Linux specific way of getting packets at the dev level.
         -- For writing rarp and other similar things on the user
         -- level.
      external "C"
      alias "const_sock_packet"
      end

   SOCK_RAW: INTEGER is
         -- Raw protocol interface.
      external "C"
      alias "const_sock_raw"
      end

   SOCK_SEQPACKET: INTEGER is
         -- Sequenced, reliable, connection-based, datagrams of fixed
         -- maximum length.
      external "C"
      alias "const_sock_seqpacket"
      end

   SOCK_STREAM: INTEGER is
         -- Sequenced, reliable, connection-based byte streams.
      external "C"
      alias "const_sock_stream"
      end

feature {NONE} -- protocol families

   AF_INET:  INTEGER is
      external "C"
      alias "const_af_inet"
      end


end
