indexing

   description: "Base class for WINDOWS classes."

   author: "Berend de Boer"
   date: "$Date: 2002/02/06 $"
   revision: "$Revision: #2 $"

class

   WINDOWS_BASE


inherit

   STDC_BASE

   WINDOWS_CONSTANTS
      export
         {NONE} all
      end

   WAPI_WINDOWS


feature {NONE} -- exceptions

   raise_windows_error is
         -- Windows specific variant of raise_posix_error
         -- uses GetLastError for error handling
         -- `security.error_handling.disable_exceptions'
      require
         -- errno_should_be_set: errno.is_not_ok
      do
         errno.set_value (posix_getlasterror)
         if security.error_handling.exceptions_enabled then
            do_raise (sh.pointer_to_string (posix_geterrormessage (errno.value)))
            -- do_raise (errno.message)
         else
            if errno.first_value = 0 then
               errno.set_first
            end
         end
      end

   safe_win_call (success: BOOLEAN) is
      do
         if not success then
            raise_windows_error
         end
      end

end
